import { __read, __assign } from 'tslib';
import { InjectionToken, Injectable, Component, Inject, HostListener, Injector, ɵɵdefineInjectable, ɵɵinject, INJECTOR, NgModule } from '@angular/core';
import { Overlay, OverlayModule } from '@angular/cdk/overlay';
import { ComponentPortal, PortalInjector } from '@angular/cdk/portal';
import { timer, BehaviorSubject, defer, interval } from 'rxjs';
import { take, withLatestFrom, filter, map, share, reduce } from 'rxjs/operators';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NotificationData = /** @class */ (function () {
    function NotificationData() {
    }
    return NotificationData;
}());
var NotificationAlertContainerStyles = /** @class */ (function () {
    function NotificationAlertContainerStyles() {
    }
    return NotificationAlertContainerStyles;
}());
var DefaultNotificationConfig = /** @class */ (function () {
    function DefaultNotificationConfig() {
        this.animation = true;
        this.dismissible = true;
        this.position = 'topLeft';
        this.timeOut = 5;
        this.unique = false;
    }
    DefaultNotificationConfig.decorators = [
        { type: Injectable }
    ];
    return DefaultNotificationConfig;
}());
/** @type {?} */
var defaultNotificationCofigValues = {
    position: 'topRight',
    animation: true,
    timeOut: 5,
    dismissible: true
};
/** @type {?} */
var NOTIFICATION_CONFIG_TOKEN = new InjectionToken('notification-config');

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxNotificationRef = /** @class */ (function () {
    function NgxNotificationRef(overlay, nt) {
        this.overlay = overlay;
        this.nt = nt;
    }
    /**
     * @return {?}
     */
    NgxNotificationRef.prototype.close = /**
     * @return {?}
     */
    function () {
        this.overlay.dispose();
        this.clearMessage();
    };
    /**
     * @return {?}
     */
    NgxNotificationRef.prototype.isVisible = /**
     * @return {?}
     */
    function () {
        return this.overlay && this.overlay.overlayElement;
    };
    /**
     * @return {?}
     */
    NgxNotificationRef.prototype.getPosition = /**
     * @return {?}
     */
    function () {
        return this.overlay.overlayElement.getBoundingClientRect();
    };
    /**
     * @return {?}
     */
    NgxNotificationRef.prototype.clearMessage = /**
     * @return {?}
     */
    function () {
        this.nt.lastMessage = null;
    };
    return NgxNotificationRef;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBootstrapAlertNotificationComponent = /** @class */ (function () {
    function NgxBootstrapAlertNotificationComponent(data, ref, containerStyles, notificationConfig) {
        this.data = data;
        this.ref = ref;
        this.containerStyles = containerStyles;
        this.notificationConfig = notificationConfig;
        this.animatedClass = 'fadeInDown';
    }
    /**
     * @return {?}
     */
    NgxBootstrapAlertNotificationComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        if (this.notificationConfig.dismissible) {
            this.dismissibleTimer();
        }
        this.show = true;
    };
    /**
     * @return {?}
     */
    NgxBootstrapAlertNotificationComponent.prototype.close = /**
     * @return {?}
     */
    function () {
        var _this = this;
        if (this.notificationConfig.animation) {
            this.animatedClass = 'fadeOutUp';
            this.show = false;
            timer(1000)
                .pipe(take(1))
                .subscribe((/**
             * @param {?} t
             * @return {?}
             */
            function (t) { return _this.ref.close(); }));
        }
        else {
            this.show = false;
            this.ref.close();
        }
    };
    /**
     * @return {?}
     */
    NgxBootstrapAlertNotificationComponent.prototype.onMouseOver = /**
     * @return {?}
     */
    function () {
        if (this.notificationConfig.dismissible) {
            this.notification.paused.next(true);
        }
    };
    /**
     * @return {?}
     */
    NgxBootstrapAlertNotificationComponent.prototype.onMouseLeave = /**
     * @return {?}
     */
    function () {
        if (this.notificationConfig.dismissible) {
            this.notification.paused.next(false);
        }
    };
    /**
     * @private
     * @return {?}
     */
    NgxBootstrapAlertNotificationComponent.prototype.dismissibleTimer = /**
     * @private
     * @return {?}
     */
    function () {
        var _this = this;
        /** @type {?} */
        var subject = new BehaviorSubject(false);
        this.notification = {
            paused: subject,
            obs: this.getPausableTimer(this.notificationConfig.timeOut, subject)
        };
        this.notification.obs.completeTimer
            .pipe(take(1))
            .subscribe((/**
         * @param {?} t
         * @return {?}
         */
        function (t) { return _this.close(); }));
    };
    /**
     * @private
     * @param {?} timeout
     * @param {?} pause
     * @return {?}
     */
    NgxBootstrapAlertNotificationComponent.prototype.getPausableTimer = /**
     * @private
     * @param {?} timeout
     * @param {?} pause
     * @return {?}
     */
    function (timeout, pause) {
        /** @type {?} */
        var pausableTimer$ = defer((/**
         * @return {?}
         */
        function () {
            /** @type {?} */
            var seconds = 1;
            return interval(1000).pipe(withLatestFrom(pause), filter((/**
             * @param {?} __0
             * @return {?}
             */
            function (_a) {
                var _b = __read(_a, 2), v = _b[0], paused = _b[1];
                return !paused;
            })), take(timeout), map((/**
             * @return {?}
             */
            function () { return seconds++; })));
        })).pipe(share());
        return {
            stepTimer: pausableTimer$,
            completeTimer: pausableTimer$.pipe(reduce((/**
             * @param {?} x
             * @param {?} y
             * @return {?}
             */
            function (x, y) { return y; })))
        };
    };
    NgxBootstrapAlertNotificationComponent.decorators = [
        { type: Component, args: [{
                    selector: 'ngx-bootstrap-alert-notification',
                    template: "\n    <div [ngStyle]=\"containerStyles\" class=\"col-11 col-sm-4 notification-container\">\n      <div *ngIf=\"!data.template\" [class.alert-dismissible]=\"notificationConfig.dismissible\"\n           [class.alert-with-icon]=\"data.icon\" [class.animated]=\"notificationConfig.animation\"\n           [class.show]=\"show\"\n           [ngClass]=\"['alert-'+data.type, animatedClass]\" class=\"alert fade\" role=\"alert\">\n        <button (click)=\"close()\" aria-label=\"Close\" class=\"close\" type=\"button\">\n          <span aria-hidden=\"true\">\u00D7</span>\n        </button>\n        <h4 *ngIf=\"data.title as title\" class=\"title\">{{title}}</h4>\n        <span *ngIf=\"data.icon as icon\" [className]=\"icon\" data-notify=\"icon\"></span>\n        <span data-notify=\"message\">\n      {{data.message}}\n    </span>\n      </div>\n      <ng-container *ngIf=\"data.template as templateRef\" [ngTemplateOutlet]=\"templateRef\"></ng-container>\n    </div>\n\n  ",
                    styles: ["\n      :host {\n        z-index: 1051;\n        position: fixed;\n        display: block;\n      }\n\n      .title {\n        margin-bottom: 0;\n        color: white;\n      }\n\n      @keyframes fadeInDown {\n        from {\n          opacity: 0;\n          transform: translate3d(0, -100%, 0);\n        }\n\n        to {\n          opacity: 1;\n          transform: translate3d(0, 0, 0);\n        }\n      }\n\n      .fadeInDown {\n        animation-name: fadeInDown;\n      }\n\n      @keyframes fadeOutUp {\n        from {\n          opacity: 1;\n        }\n\n        to {\n          opacity: 0;\n          transform: translate3d(0, -100%, 0);\n        }\n      }\n\n      .fadeOutUp {\n        animation-name: fadeOutUp;\n      }\n\n      .animated {\n        animation-duration: 1s;\n        animation-fill-mode: both;\n      }\n    "]
                }] }
    ];
    /** @nocollapse */
    NgxBootstrapAlertNotificationComponent.ctorParameters = function () { return [
        { type: NotificationData },
        { type: NgxNotificationRef },
        { type: NotificationAlertContainerStyles },
        { type: undefined, decorators: [{ type: Inject, args: [DefaultNotificationConfig,] }] }
    ]; };
    NgxBootstrapAlertNotificationComponent.propDecorators = {
        onMouseOver: [{ type: HostListener, args: ['mouseover',] }],
        onMouseLeave: [{ type: HostListener, args: ['mouseleave',] }]
    };
    return NgxBootstrapAlertNotificationComponent;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/** @type {?} */
var Styles = {
    display: 'inline-block',
    margin: '0px auto',
    position: 'fixed',
    transition: 'all 0.5s ease-in-out',
    zIndex: '1031'
};
var NgxBootstrapAlertNotificationService = /** @class */ (function () {
    function NgxBootstrapAlertNotificationService(overlay, parentInjector, notificationConfig) {
        this.overlay = overlay;
        this.parentInjector = parentInjector;
        this.notificationConfig = notificationConfig;
    }
    Object.defineProperty(NgxBootstrapAlertNotificationService.prototype, "lastMessage", {
        set: /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this._lastMessage = value;
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @param {?} data
     * @param {?=} config
     * @return {?}
     */
    NgxBootstrapAlertNotificationService.prototype.show = /**
     * @param {?} data
     * @param {?=} config
     * @return {?}
     */
    function (data, config) {
        if (!config || config && !config.unique ||
            (config && config.unique &&
                ((Array.isArray(this._lastMessage) &&
                    (this._lastMessage || []).includes(data.message)) ||
                    this._lastMessage !== data.message))) {
            this._lastMessage = data.message;
            /** @type {?} */
            var positionStrategy = this.getPositionStrategy();
            /** @type {?} */
            var overlayRef = this.overlay.create({ positionStrategy: positionStrategy });
            /** @type {?} */
            var notificationRef = new NgxNotificationRef(overlayRef, this.parentInjector.get(NgxBootstrapAlertNotificationService));
            /** @type {?} */
            var injector = this.getInjector(data, notificationRef, this.parentInjector, config, this.createContainerStyles(config));
            this.lastNotification = notificationRef;
            /** @type {?} */
            var toastPortal = new ComponentPortal(NgxBootstrapAlertNotificationComponent, null, injector);
            overlayRef.attach(toastPortal);
            return notificationRef;
        }
        return null;
    };
    /**
     * @return {?}
     */
    NgxBootstrapAlertNotificationService.prototype.getPositionStrategy = /**
     * @return {?}
     */
    function () {
        return this.overlay.position().global();
    };
    /**
     * @param {?} data
     * @param {?} notificationRef
     * @param {?} parentInjector
     * @param {?=} notificationConfig
     * @param {?=} containerStyles
     * @return {?}
     */
    NgxBootstrapAlertNotificationService.prototype.getInjector = /**
     * @param {?} data
     * @param {?} notificationRef
     * @param {?} parentInjector
     * @param {?=} notificationConfig
     * @param {?=} containerStyles
     * @return {?}
     */
    function (data, notificationRef, parentInjector, notificationConfig, containerStyles) {
        /** @type {?} */
        var tokens = new WeakMap();
        tokens.set(NotificationData, data);
        tokens.set(NgxNotificationRef, notificationRef);
        if (notificationConfig) {
            notificationConfig = __assign({}, this.notificationConfig, notificationConfig);
            tokens.set(DefaultNotificationConfig, notificationConfig);
        }
        if (containerStyles) {
            tokens.set(NotificationAlertContainerStyles, containerStyles);
        }
        return new PortalInjector(parentInjector, tokens);
    };
    /**
     * @private
     * @param {?=} config
     * @return {?}
     */
    NgxBootstrapAlertNotificationService.prototype.createContainerStyles = /**
     * @private
     * @param {?=} config
     * @return {?}
     */
    function (config) {
        /** @type {?} */
        var styles = __assign({}, Styles);
        /** @type {?} */
        var notificationContainer;
        if (this.lastNotification) {
            /** @type {?} */
            var element = this.lastNotification.isVisible();
            notificationContainer = element
                ? element.querySelector('.notification-container')
                : null;
        }
        /** @type {?} */
        var conf = __assign({}, this.notificationConfig, (config || {}));
        if (conf.position && conf.position.includes('top')) {
            styles.top =
                notificationContainer && notificationContainer.style.top
                    ? parseFloat(notificationContainer.style.top) +
                        notificationContainer.clientHeight + "px"
                    : '20px';
            switch (conf.position) {
                case 'topLeft':
                    styles.left = '20px';
                    break;
                case 'topCenter':
                    styles.left = '0px';
                    styles.right = '0px';
                    break;
                case 'topRight':
                    styles.right = '20px';
                    break;
                default:
                    break;
            }
        }
        else {
            styles.bottom =
                notificationContainer && notificationContainer.style.bottom
                    ? parseFloat(notificationContainer.style.bottom) +
                        notificationContainer.clientHeight + "px"
                    : '20px';
            switch (conf.position) {
                case 'bottomLeft':
                    styles.left = '20px';
                    break;
                case 'bottomCenter':
                    styles.left = '0px';
                    styles.right = '0px';
                    break;
                case 'bottomRight':
                    styles.right = '20px';
                    break;
                default:
                    break;
            }
        }
        return styles;
    };
    NgxBootstrapAlertNotificationService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NgxBootstrapAlertNotificationService.ctorParameters = function () { return [
        { type: Overlay },
        { type: Injector },
        { type: undefined, decorators: [{ type: Inject, args: [DefaultNotificationConfig,] }] }
    ]; };
    /** @nocollapse */ NgxBootstrapAlertNotificationService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NgxBootstrapAlertNotificationService_Factory() { return new NgxBootstrapAlertNotificationService(ɵɵinject(Overlay), ɵɵinject(INJECTOR), ɵɵinject(DefaultNotificationConfig)); }, token: NgxBootstrapAlertNotificationService, providedIn: "root" });
    return NgxBootstrapAlertNotificationService;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NgxBootstrapAlertNotificationModule = /** @class */ (function () {
    function NgxBootstrapAlertNotificationModule() {
    }
    /**
     * @param {?=} config
     * @return {?}
     */
    NgxBootstrapAlertNotificationModule.forRoot = /**
     * @param {?=} config
     * @return {?}
     */
    function (config) {
        return {
            ngModule: NgxBootstrapAlertNotificationModule,
            providers: [
                {
                    provide: DefaultNotificationConfig,
                    useValue: config ? config : defaultNotificationCofigValues
                }
            ]
        };
    };
    NgxBootstrapAlertNotificationModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [NgxBootstrapAlertNotificationComponent],
                    imports: [CommonModule, OverlayModule],
                    entryComponents: [NgxBootstrapAlertNotificationComponent],
                    exports: [NgxBootstrapAlertNotificationComponent]
                },] }
    ];
    return NgxBootstrapAlertNotificationModule;
}());

export { NgxBootstrapAlertNotificationComponent, NgxBootstrapAlertNotificationModule, NgxBootstrapAlertNotificationService, NotificationData as ɵa, NotificationAlertContainerStyles as ɵb, DefaultNotificationConfig as ɵd, defaultNotificationCofigValues as ɵe, NgxNotificationRef as ɵf };
//# sourceMappingURL=benevideschissanga-ngx-bootstrap-alert-notification.js.map
