import { InjectionToken, TemplateRef } from '@angular/core';
export declare class NotificationData {
    type: NotificationType;
    title?: string;
    icon?: string;
    message?: string;
    template?: TemplateRef<any>;
    templateContext?: {};
}
export declare class NotificationAlertContainerStyles {
    display: string;
    margin: string;
    position: string;
    transition: string;
    zIndex: string;
    top?: string;
    left?: string;
    bottom?: string;
    right?: string;
}
export declare type NotificationType = 'warning' | 'success' | 'primary' | 'info' | 'danger';
export interface NgxNotificationConfig {
    position?: 'topLeft' | 'topCenter' | 'topRight' | 'bottomLeft' | 'bottomCenter' | 'bottomRight' | any;
    animation?: boolean;
    timeOut?: number;
    dismissible?: boolean;
    unique?: boolean;
}
export declare class DefaultNotificationConfig implements NgxNotificationConfig {
    animation: boolean;
    dismissible: boolean;
    position: string;
    timeOut: number;
    unique: boolean;
}
export declare const defaultNotificationCofigValues: {
    position: string;
    animation: boolean;
    timeOut: number;
    dismissible: boolean;
};
export declare const NOTIFICATION_CONFIG_TOKEN: InjectionToken<{}>;
